#!/bin/csh
#
# Harissa, copyright (C) Irisa/Inria 1996
#
# $Id: harissa_config.csh,v 1.3 1997/12/03 09:47:37 ups Exp $
#
# $Log: harissa_config.csh,v $
# Revision 1.3  1997/12/03 09:47:37  ups
# Cleaned up so that it's easier for end users to modify
#
# Revision 1.2  1997/10/27 12:04:07  ups
# Replaced the 'setenv HARISSAHOME /udd/whatever' with 'setenv HARISSAHOME /.automount/compose/export/home/compose/d01/compose/muller/Java/harissa/www-inst',
# this line is the modified by the Makefile to point to wherever Harissa is
# installed.
#
# Revision 1.1  1997/10/27 11:52:46  ups
# Initial revision
#
# Revision 1.2  1996/09/18 10:34:13  muller
# *** empty log message ***
#
# Revision 1.1  1996/09/12 14:16:40  bellard
# Initial revision
#
#
#

#
# harissa config for csh compatible shells. To load it:
# source harissa_config.csh
#

# on Linux, you may have to uncomment this line, depending on you configuration:
#setenv LD_LIBRARY_PATH /usr/X11/lib

# set the HARISSAHOME variable to point to your harissa installation
# (example: setenv HARISSAHOME /home/foo/packages/harissa)

setenv HARISSAHOME /usr/local/harissa

# set the JDKLIB variable with the directory where the file "classes.zip" can be found
# (example: setenv JDKLIB /usr/local/lib/java/lib)

setenv JDKLIB /usr/local/jdk/lib

# Uncomment one of these two lines to chose between the GC and non GC configuration
# (in general: GC for single-threaded applications, non-GC for multithreaded ones)

setenv HARISSA_LIB_MEM $HARISSAHOME/lib/mmwithgc
#setenv HARISSA_LIB_MEM ${HARISSAHOME}/lib/mmwithout

# The rest should work fine without modifications

if ( $?LD_LIBRARY_PATH ) then
   setenv LD_LIBRARY_PATH "${HARISSAHOME}/lib:${HARISSA_LIB_MEM}:${LD_LIBRARY_PATH}"
else
   setenv LD_LIBRARY_PATH "${HARISSAHOME}/lib:${HARISSA_LIB_MEM}"
endif

set path = ( ${HARISSAHOME}/bin $path )
#setenv CLASSPATH ${JDKLIB}/classes.zip\:.
if ( $?CLASSPATH ) then
  setenv CLASSPATH ${HARISSAHOME}/libbiss/biss-0.87/lib:${JDKLIB}/classes.zip:.:${CLASSPATH}
else
  setenv CLASSPATH ${HARISSAHOME}/libbiss/biss-0.87/lib:${JDKLIB}/classes.zip:.
endif

echo Environment modified to use Harissa installed in ${HARISSAHOME}
