/*
 * Harissa, copyright (C) Irisa/Inria 1996
 *
 * $Id: config.h,v 1.7 1997/12/16 12:49:43 ups Exp $
 *
 * $Log: config.h,v $
 * Revision 1.7  1997/12/16 12:49:43  ups
 * - Changed version from 3.01 to 3.02
 *
 * Revision 1.6  1997/12/11 15:53:57  ups
 * Correct v3.1 to v3.01
 *
 * Revision 1.5  1997/11/21 15:52:14  ups
 * Imported seperate branch from ups: CC compability
 *
 * Revision 1.4  1997/10/16 13:20:54  muller
 * - version alpha 3.0
 *
 * Revision 1.3  1997/05/07 13:25:24  muller
 * - version publique alpha2.2
 *
 * Revision 1.2  1997/01/08 12:40:07  muller
 * -salsa alpha2 public release
 *
 * Revision 1.1  1996/09/12 07:44:38  bellard
 * Initial revision
 *
 *
 */

/* types for Java */
typedef char TBYTE;
typedef int TINT;
typedef short TSHORT;
typedef long long TLONG;
typedef unsigned long long TULONG;
typedef unsigned short TCHAR;
typedef float TFLOAT;
typedef double TDOUBLE;
typedef int TBOOL;
typedef struct Object *TREF;

typedef char u1;
typedef short u2;
typedef int u4;

#define MK_TLONG(r,d1,d2) { r=((TLONG)(d1)<<32) | (TLONG)(d2); }

#define MK_TFLOAT(r,i)    { r=*(float *)(&(i)); }

#define MK_TDOUBLE(r,l) { r=*(double *)(&(l)); }

#define PATH_SIZE_MAX 1024

#define HARISSA_VERSION    "alpha3.02"
#define HARISSA_CLASS_VERSION "45.3"
#define HARISSA_VENDOR     "FREE"
#define HARISSA_VENDOR_URL "http://www.irisa.fr/EXTERNE/projet/lande/consel/index.html"
#define HARISSA_HOME_ENV   "HARISSAHOME"
#define	HARISSA_CLASSPATH_ENV "CLASSPATH"

#if defined(WIN32) || defined(OS2)
#define	PATH_SEP ';'
#define FILE_SEP '\\'
#define LINE_SEP "\r\n"  
#else
#define	PATH_SEP ':'
#define FILE_SEP '/'
#define LINE_SEP "\n"
#endif

#if defined(SUNOS)
#define NATIVE_STUB_NAME   "_%s_stub"
#else 
#define NATIVE_STUB_NAME   "%s_stub"
#endif

/* Alignment (highly machine dependent for any compiler but gcc) */

#ifdef __GNUC__ /* No problem, the __alignof__ macro is defined! */

/* Basic types: */
#define __alignof_TBYTE __alignof__(TBYTE)
#define __alignof_TINT __alignof__(TINT)
#define __alignof_TSHORT __alignof__(TSHORT)
#define __alignof_TLONG __alignof__(TLONG)
#define __alignof_TULONG __alignof__(TULONG)
#define __alignof_TCHAR __alignof__(TCHAR)
#define __alignof_TFLOAT __alignof__(TFLOAT)
#define __alignof_TDOUBLE __alignof__(TDOUBLE)
#define __alignof_TBOOL __alignof__(TBOOL)
#define __alignof_Object __alignof__(Object)
#define __alignof_TREF __alignof__(TREF)

/* Other things: */
#define __alignof_ObjectHeader __alignof__(ObjectHeader)

#else /* We have a problem; we try to guess */

/* (there is a test program that verifies the guesses in "test_suite/Basic") */

/* Basic types: */
#define __alignof_TBYTE 1
#define __alignof_TINT 4
#define __alignof_TSHORT 2
#define __alignof_TLONG 8
#define __alignof_TULONG 8
#define __alignof_TCHAR 2
#define __alignof_TFLOAT 4
#define __alignof_TDOUBLE 8
#define __alignof_TBOOL 4
#define __alignof_Object 4
#define __alignof_TREF 4

/* Other things: */
#define __alignof_ObjectHeader 4

#endif /* __GNUC__ */
