/*
 * Harissa, copyright (C) Irisa/Inria 1996
 *
 * $Id: harissa.h,v 1.7 1997/12/04 10:21:29 ups Exp $
 *
 * $Log: harissa.h,v $
 * Revision 1.7  1997/12/04 10:21:29  ups
 * Added out-commented definition of _MIT_POSIX_THREADS, for possible use with Linux
 *
 * Revision 1.6  1997/12/02 14:45:02  ups
 * Changed the non-gcc definition of __FUNCTION__ to something more appropriate
 *
 * Revision 1.5  1997/11/21 15:52:15  ups
 * Imported seperate branch from ups: CC compability
 *
 * Revision 1.4  1997/05/07 13:25:47  muller
 * - version publique alpha2.2
 *
 * Revision 1.3  1996/12/02 14:11:47  muller
 * Support for div by 0 and null pointers added
 *
 * Revision 1.2  1996/09/18 10:43:39  muller
 * babe -> salsa
 *
 * Revision 1.1  1996/09/11 19:19:36  muller
 * Initial revision
 *
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <setjmp.h>
#include <signal.h>

/* On linux, you may have to uncomment this line: */

/* #define _MIT_POSIX_THREADS 1 */

#ifndef __GNUC__
/* Attribute is supported only by GCC */
#define __attribute__(f)
/* inline is only supported by GCC */
#  define inline
/* the symbol __FUNCTION__ seems to be defined by GnuC... */
#  define __FUNCTION__ "FUNCTION_NAME_NOT_ACCESSIBLE_IN_CC_VERSION"
#endif

#include <config.h>
#include <harissa_types.h>
#include <harissa_support.h>
#include "bytecode.h"

/* debugging */

void initDebug(void);
void endDebug(void);

#ifndef TEMPO
void ddprintf(char *format,...);

#  ifdef DEBUGL

#    define dlprintf(level,format, args...)				\
{								\
  if (DEBUGL>=level) { 						\
    ddprintf("In '%s': " format "\n",__FUNCTION__, ##args);	\
  }								\
}

#  else 

#    ifdef __GNUC__
#      define dlprintf(level,format, args...)
#    else
#      define dlprintf() /* Generates a warning, but works! */
#    endif
#  endif

#  ifdef DEBUG

#    ifdef __GNUC__
#      define dprintf(format, args...)  \
  ddprintf("In '%s': " format "\n",__FUNCTION__, ##args);
#    else
#      define dprintf() /* Generates a warning, but works */
#    endif

#  else

#    ifdef __GNUC__
#      define dprintf(format, args...)
#    else
#      define dprintf() /* Generates a warning, but works */
#    endif

#  endif

#endif /*TEMPO*/
