/*
 * Harissa, copyright (C) Irisa/Inria 1996
 *
 * $Id: my_thread.h,v 1.4 1997/12/02 15:15:50 muller Exp $
 *
 * $Log: my_thread.h,v $
 * Revision 1.4  1997/12/02 15:15:50  muller
 * - moving from semaphore to mutex
 *
 * Revision 1.3  1997/11/25 10:02:18  muller
 * - support for daemon threads
 *
 * Revision 1.2  1997/11/17 17:18:35  muller
 * - multithreaded environment for exceptions
 * - some cleaning
 *
 * Revision 1.1  1997/10/16 13:17:10  muller
 * Initial revision
 *
 */

#include <pthread.h>

/* thread-specific info */
struct mythread {
  TREF exception_obj;		/* current exception */
  ExceptionEnv *exception_env;
  int exception_count;	        /* number of uncaught exceptions */
};

struct monitor {
  pthread_mutex_t lock;
  pthread_cond_t  cond;
  struct mythread *thread;
  int refc;
  int nwaiting;
  int nsignals;
};

/* per-thread control block */
typedef struct tcb {
    struct mythread mythread;		/* per-thread information */
    struct Hjava_lang_Thread *obj;	/* the Thread object */
    pthread_t thread;			/* solaris thread id */
    int state;				/* thread state */
} tcb;

tcb *pthread_cur();
void sthread_setpriority(struct Hjava_lang_Thread *o, int priority);
void pthread_sleep(TLONG millis);
tcb *pthread_cur();
void pthread_cr(struct Hjava_lang_Thread *o);
void pthread_setpriority(struct Hjava_lang_Thread *o, int priority);
struct mythread *mythread();
void pthread_c_w(struct monitor *m, TLONG timeout);
void pthread_cond_sig(struct monitor *m);
void pthread_cond_br(struct monitor *m);
